import type { Context } from 'aws-lambda';
export type ReleaseNotesGenerateEvent = {
    tarballUri: string;
};
/**
 * * @param event: ReleaseNotesGenerateEvent
 *
 * Lambda function to generate release notes from Github
 * The lambda tries to get generate release notes from
 * 1. Github release for the given version number
 * 2. Github releases page (in case the version number is not exact match)
 * 3. changelog.md or similar changelog files
 * The repository information is determined by reading the package.json file
 * for the given package
 */
export declare const handler: (event: ReleaseNotesGenerateEvent, context: Context) => Promise<{
    error: string;
    releaseNotes?: undefined;
} | {
    error: null;
    releaseNotes: string | void;
}>;
