import { SQSEvent } from 'aws-lambda';
/**
 *
 * @param event SQSEvent
 * The lambda functions moves the messages from the release notes
 * fetch queue to worker queue. These queues are kept separate so the
 * release notes fetch task can respect the Github API service limits
 * The release notes queue is the queue is intake queue and this lambda
 * gets triggered when there is a new message. When triggered the messages
 * are moved from intake queue to worker queue which is handled by Step function
 *
 * As part of execution of this lambda ensures that an instance of the release
 * note step function is executing to process the messages in worker queue.
 * @returns void
 */
export declare const handler: (event: SQSEvent) => Promise<void>;
